// $Id: pac_output.h 1431 2005-09-30 20:48:04Z vern $

#ifndef pac_output_h
#define pac_output_h

#include <stdarg.h>
#include <stdio.h>

class OutputException {
public:
	OutputException(const char* arg_msg);
	OutputException(const OutputException &oe)
		{ *this = oe; }
	~OutputException();

	const char* errmsg() const { return msg; }

	OutputException& operator=(const OutputException& oe);

protected:
	char* msg;
};

class Output {
public:
	Output(const char *filename);
	~Output();

	int println(const char* fmt, ...);
	int print(const char* fmt, ...);

	void inc_indent() { ++indent; }
	void dec_indent() { --indent; }

protected:
	int print(const char* fmt, va_list ap);

	FILE* fp;
	int indent;
};

const char* fmt(const char* fmt, ...);
char* nfmt(const char* fmt, ...);

#endif /* pac_output_h */
