// This file is automatically generated from dce_rpc.pac.

#ifndef dce_rpc_pac_h
#define dce_rpc_pac_h

#include <vector>

#include "binpac/binpac.h"

namespace BinPAC {

enum dce_rpc_ptype {
	DCE_RPC_REQUEST,
	DCE_RPC_PING,
	DCE_RPC_RESPONSE,
	DCE_RPC_FAULT,
	DCE_RPC_WORKING,
	DCE_RPC_NOCALL,
	DCE_RPC_REJECT,
	DCE_RPC_ACK,
	DCE_RPC_CL_CANCEL,
	DCE_RPC_FACK,
	DCE_RPC_CANCEL_ACK,
	DCE_RPC_BIND,
	DCE_RPC_BIND_ACK,
	DCE_RPC_BIND_NAK,
	DCE_RPC_ALTER_CONTEXT,
	DCE_RPC_ALTER_CONTEXT_RESP,
	DCE_RPC_SHUTDOWN,
	DCE_RPC_CO_CANCEL,
	DCE_RPC_ORPHANED,
};

class uuid
{
public:
	uuid();
	~uuid();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	array<uint8> const & val() const	{ return val_; }
	
protected:
	array<uint8> val_;
};


class context_handle
{
public:
	context_handle();
	~context_handle();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint32 const & cxt_attributes() const	{ return cxt_attributes_; }
	uuid * const & cxt_uuid() const	{ return cxt_uuid_; }
	
protected:
	uint32 cxt_attributes_;
	uuid * cxt_uuid_;
};


class rpc_if_id_t
{
public:
	rpc_if_id_t();
	~rpc_if_id_t();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uuid * const & if_uuid() const	{ return if_uuid_; }
	uint16 const & vers_major() const	{ return vers_major_; }
	uint16 const & vers_minor() const	{ return vers_minor_; }
	
protected:
	uuid * if_uuid_;
	uint16 vers_major_;
	uint16 vers_minor_;
};


class NDR_Format
{
public:
	NDR_Format();
	~NDR_Format();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint8 const & intchar() const	{ return intchar_; }
	uint8 const & floatspec() const	{ return floatspec_; }
	int const & byteorder() const 	{ return byteorder_; }
	
protected:
	uint8 intchar_;
	uint8 floatspec_;
	int byteorder_;
};


class DCE_RPC_Header
{
public:
	DCE_RPC_Header();
	~DCE_RPC_Header();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	int const byteorder() const { return byteorder_; };
	uint8 const & rpc_vers() const	{ return rpc_vers_; }
	uint8 const & rpc_vers_minor() const	{ return rpc_vers_minor_; }
	uint8 const & PTYPE() const	{ return PTYPE_; }
	uint8 const & pfc_flags() const	{ return pfc_flags_; }
	NDR_Format * const & packed_drep() const	{ return packed_drep_; }
	uint16 const & frag_length() const	{ return frag_length_; }
	uint16 const & auth_length() const	{ return auth_length_; }
	uint32 const & call_id() const	{ return call_id_; }
	
protected:
	int byteorder_;
	uint8 rpc_vers_;
	uint8 rpc_vers_minor_;
	uint8 PTYPE_;
	uint8 pfc_flags_;
	NDR_Format * packed_drep_;
	uint16 frag_length_;
	uint16 auth_length_;
	uint32 call_id_;
};


class p_context_id_t
{
public:
	p_context_id_t();
	~p_context_id_t();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint16 const & val() const	{ return val_; }
	
protected:
	uint16 val_;
};


class p_syntax_id_t
{
public:
	p_syntax_id_t();
	~p_syntax_id_t();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uuid * const & if_uuid() const	{ return if_uuid_; }
	uint32 const & if_version() const	{ return if_version_; }
	
protected:
	uuid * if_uuid_;
	uint32 if_version_;
};


class p_cont_elem_t
{
public:
	p_cont_elem_t();
	~p_cont_elem_t();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	p_context_id_t * const & p_cont_id() const	{ return p_cont_id_; }
	uint8 const & n_transfer_syn() const	{ return n_transfer_syn_; }
	p_syntax_id_t * const & abstract_syntax() const	{ return abstract_syntax_; }
	array<p_syntax_id_t *> const & transfer_syntaxes() const	{ return transfer_syntaxes_; }
	
protected:
	p_context_id_t * p_cont_id_;
	uint8 n_transfer_syn_;
	p_syntax_id_t * abstract_syntax_;
	array<p_syntax_id_t *> transfer_syntaxes_;
};


class p_cont_list_t
{
public:
	p_cont_list_t();
	~p_cont_list_t();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint8 const & n_context_elem() const	{ return n_context_elem_; }
	array<p_cont_elem_t *> const & p_cont_elem() const	{ return p_cont_elem_; }
	
protected:
	uint8 n_context_elem_;
	array<p_cont_elem_t *> p_cont_elem_;
};


class DCE_RPC_Bind
{
public:
	DCE_RPC_Bind();
	~DCE_RPC_Bind();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint16 const & max_xmit_frag() const	{ return max_xmit_frag_; }
	uint16 const & max_recv_frag() const	{ return max_recv_frag_; }
	uint32 const & assoc_group_id() const	{ return assoc_group_id_; }
	p_cont_list_t * const & p_context_elem() const	{ return p_context_elem_; }
	
protected:
	uint16 max_xmit_frag_;
	uint16 max_recv_frag_;
	uint32 assoc_group_id_;
	p_cont_list_t * p_context_elem_;
};


class DCE_RPC_Request
{
public:
	DCE_RPC_Request(int arg_length);
	~DCE_RPC_Request();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	int const length() const { return length_; };
	uint32 const & alloc_hint() const	{ return alloc_hint_; }
	p_context_id_t * const & p_cont_id() const	{ return p_cont_id_; }
	uint16 const & opnum() const	{ return opnum_; }
	array<uint8> const & stub() const	{ return stub_; }
	
protected:
	int length_;
	uint32 alloc_hint_;
	p_context_id_t * p_cont_id_;
	uint16 opnum_;
	array<uint8> stub_;
};


class DCE_RPC_Response
{
public:
	DCE_RPC_Response(int arg_length);
	~DCE_RPC_Response();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	int const length() const { return length_; };
	uint32 const & alloc_hint() const	{ return alloc_hint_; }
	p_context_id_t * const & p_cont_id() const	{ return p_cont_id_; }
	uint8 const & cancel_count() const	{ return cancel_count_; }
	uint8 const & reserved() const	{ return reserved_; }
	array<uint8> const & stub() const	{ return stub_; }
	
protected:
	int length_;
	uint32 alloc_hint_;
	p_context_id_t * p_cont_id_;
	uint8 cancel_count_;
	uint8 reserved_;
	array<uint8> stub_;
};


class DCE_RPC_Body
{
public:
	DCE_RPC_Body(DCE_RPC_Header* arg_header, int arg_length);
	~DCE_RPC_Body();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	DCE_RPC_Header* const header() const { return header_; };
	int const length() const { return length_; };
	int val_case_index() const	{ return val_case_index_; }
	DCE_RPC_Bind * const & bind() const
		{
		if ( val_case_index() == 11 )
			return val_.bind_;
		else
			throw ExceptionInvalidCase("./dce_rpc.pac:108:bind", val_case_index(), 11);
		}
	DCE_RPC_Request * const & request() const
		{
		if ( val_case_index() == 0 )
			return val_.request_;
		else
			throw ExceptionInvalidCase("./dce_rpc.pac:109:request", val_case_index(), 0);
		}
	DCE_RPC_Response * const & response() const
		{
		if ( val_case_index() == 2 )
			return val_.response_;
		else
			throw ExceptionInvalidCase("./dce_rpc.pac:110:response", val_case_index(), 2);
		}
	array<uint8> const & other() const
		{
		return val_.other_;
		}
	
protected:
	DCE_RPC_Header* header_;
	int length_;
	int val_case_index_;
	union {
		DCE_RPC_Bind * bind_;
		DCE_RPC_Request * request_;
		DCE_RPC_Response * response_;
		array<uint8> other_;
	} val_;
};


class DCE_RPC_Auth
{
public:
	DCE_RPC_Auth(DCE_RPC_Header* arg_header);
	~DCE_RPC_Auth();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	DCE_RPC_Header* const header() const { return header_; };
	int val_case_index() const	{ return val_case_index_; }
	array<uint8> const & auth_verifier() const
		{
		return val_.auth_verifier_;
		}
	
protected:
	DCE_RPC_Header* header_;
	int val_case_index_;
	union {
		array<uint8> auth_verifier_;
	} val_;
};


class DCE_RPC_PDU
{
public:
	DCE_RPC_PDU();
	~DCE_RPC_PDU();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	int const byteorder() const { return byteorder_; };
	int const & body_length() const 	{ return body_length_; }
	DCE_RPC_Header * const & header() const	{ return header_; }
	DCE_RPC_Body * const & body() const	{ return body_; }
	DCE_RPC_Auth * const & auth() const	{ return auth_; }
	
protected:
	int byteorder_;
	int body_length_;
	DCE_RPC_Header * header_;
	DCE_RPC_Body * body_;
	DCE_RPC_Auth * auth_;
};


class epmapper_lookup_req
{
public:
	epmapper_lookup_req();
	~epmapper_lookup_req();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint32 const & inquiry_type() const	{ return inquiry_type_; }
	uint32 const & object() const	{ return object_; }
	uint32 const & interface_id() const	{ return interface_id_; }
	uint32 const & vers_option() const	{ return vers_option_; }
	context_handle * const & entry_handle() const	{ return entry_handle_; }
	
protected:
	uint32 inquiry_type_;
	uint32 object_;
	uint32 interface_id_;
	uint32 vers_option_;
	context_handle * entry_handle_;
};


class epmapper_map_req
{
public:
	epmapper_map_req();
	~epmapper_map_req();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	
protected:
};


class epm_uuid
{
public:
	epm_uuid();
	~epm_uuid();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	int const byteorder() const { return byteorder_; };
	uuid * const & if_uuid() const	{ return if_uuid_; }
	uint16 const & if_version() const	{ return if_version_; }
	
protected:
	int byteorder_;
	uuid * if_uuid_;
	uint16 if_version_;
};


class epm_port
{
public:
	epm_port();
	~epm_port();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	int const byteorder() const { return byteorder_; };
	uint16 const & val() const	{ return val_; }
	
protected:
	int byteorder_;
	uint16 val_;
};


class epm_ip
{
public:
	epm_ip();
	~epm_ip();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	int const byteorder() const { return byteorder_; };
	uint32 const & val() const	{ return val_; }
	
protected:
	int byteorder_;
	uint32 val_;
};

enum epm_protocol {
	EPM_PROTOCOL_TCP = 7,
	EPM_PROTOCOL_UDP = 8,
	EPM_PROTOCOL_IP = 9,
	EPM_PROTOCOL_UUID = 13,
};

class epm_lhs_data
{
public:
	epm_lhs_data(int arg_length, int arg_protocol);
	~epm_lhs_data();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	int const length() const { return length_; };
	int const protocol() const { return protocol_; };
	int val_case_index() const	{ return val_case_index_; }
	epm_uuid * const & uuid() const
		{
		if ( val_case_index() == 13 )
			return val_.uuid_;
		else
			throw ExceptionInvalidCase("./dce_rpc.pac:159:uuid", val_case_index(), 13);
		}
	array<uint8> const & other() const
		{
		return val_.other_;
		}
	
protected:
	int length_;
	int protocol_;
	int val_case_index_;
	union {
		epm_uuid * uuid_;
		array<uint8> other_;
	} val_;
};


class epm_rhs_data
{
public:
	epm_rhs_data(int arg_length, int arg_protocol);
	~epm_rhs_data();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	int const length() const { return length_; };
	int const protocol() const { return protocol_; };
	int val_case_index() const	{ return val_case_index_; }
	epm_port * const & tcp() const
		{
		if ( val_case_index() == 7 )
			return val_.tcp_;
		else
			throw ExceptionInvalidCase("./dce_rpc.pac:164:tcp", val_case_index(), 7);
		}
	epm_port * const & udp() const
		{
		if ( val_case_index() == 8 )
			return val_.udp_;
		else
			throw ExceptionInvalidCase("./dce_rpc.pac:165:udp", val_case_index(), 8);
		}
	epm_ip * const & ip() const
		{
		if ( val_case_index() == 9 )
			return val_.ip_;
		else
			throw ExceptionInvalidCase("./dce_rpc.pac:166:ip", val_case_index(), 9);
		}
	array<uint8> const & other() const
		{
		return val_.other_;
		}
	
protected:
	int length_;
	int protocol_;
	int val_case_index_;
	union {
		epm_port * tcp_;
		epm_port * udp_;
		epm_ip * ip_;
		array<uint8> other_;
	} val_;
};


class epm_lhs
{
public:
	epm_lhs();
	~epm_lhs();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	int const byteorder() const { return byteorder_; };
	uint16 const & length() const	{ return length_; }
	uint8 const & protocol() const	{ return protocol_; }
	epm_lhs_data * const & data() const	{ return data_; }
	
protected:
	int byteorder_;
	uint16 length_;
	uint8 protocol_;
	epm_lhs_data * data_;
};


class epm_rhs
{
public:
	epm_rhs(int arg_protocol);
	~epm_rhs();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	int const protocol() const { return protocol_; };
	int const byteorder() const { return byteorder_; };
	uint16 const & length() const	{ return length_; }
	epm_rhs_data * const & data() const	{ return data_; }
	
protected:
	int protocol_;
	int byteorder_;
	uint16 length_;
	epm_rhs_data * data_;
};


class epm_floor
{
public:
	epm_floor();
	~epm_floor();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	int const & protocol() const 	{ return protocol_; }
	epm_lhs * const & lhs() const	{ return lhs_; }
	epm_rhs * const & rhs() const	{ return rhs_; }
	
protected:
	int protocol_;
	epm_lhs * lhs_;
	epm_rhs * rhs_;
};


class epm_tower
{
public:
	epm_tower();
	~epm_tower();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	int const byteorder() const { return byteorder_; };
	uint16 const & num_floors() const	{ return num_floors_; }
	array<epm_floor *> const & floors() const	{ return floors_; }
	
protected:
	int byteorder_;
	uint16 num_floors_;
	array<epm_floor *> floors_;
};


class epm_twr_p
{
public:
	epm_twr_p();
	~epm_twr_p();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint32 const & ref() const	{ return ref_; }
	uint32 const & length() const	{ return length_; }
	uint32 const & tower_length() const	{ return tower_length_; }
	epm_tower * const & tower() const	{ return tower_; }
	
protected:
	uint32 ref_;
	uint32 length_;
	uint32 tower_length_;
	epm_tower * tower_;
};


class epm_tower_array
{
public:
	epm_tower_array();
	~epm_tower_array();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint32 const & max_count() const	{ return max_count_; }
	uint32 const & offset() const	{ return offset_; }
	uint32 const & actual_count() const	{ return actual_count_; }
	array<epm_twr_p *> const & towers() const	{ return towers_; }
	
protected:
	uint32 max_count_;
	uint32 offset_;
	uint32 actual_count_;
	array<epm_twr_p *> towers_;
};


class epmapper_map_resp
{
public:
	epmapper_map_resp();
	~epmapper_map_resp();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	context_handle * const & entry_handle() const	{ return entry_handle_; }
	uint32 const & num_towers() const	{ return num_towers_; }
	epm_tower_array * const & towers() const	{ return towers_; }
	uint32 const & return_code() const	{ return return_code_; }
	
protected:
	context_handle * entry_handle_;
	uint32 num_towers_;
	epm_tower_array * towers_;
	uint32 return_code_;
};

} /* namespace BinPAC */
#endif /* dce_rpc_pac_h */
