// This file is automatically generated from smb.pac.

#ifndef smb_pac_h
#define smb_pac_h

#include <vector>

#include "binpac/binpac.h"

namespace BinPAC {

static const int byteorder = littleendian;

class SMB_dos_error
{
public:
	SMB_dos_error();
	~SMB_dos_error();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint8 const & error_class() const	{ return error_class_; }
	uint8 const & reserved() const	{ return reserved_; }
	uint16 const & error() const	{ return error_; }
	
protected:
	uint8 error_class_;
	uint8 reserved_;
	uint16 error_;
};


class SMB_error
{
public:
	SMB_error(int arg_err_status_type);
	~SMB_error();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	int const err_status_type() const { return err_status_type_; };
	int val_case_index() const	{ return val_case_index_; }
	SMB_dos_error * const & dos_error() const
		{
		if ( val_case_index() == 0 )
			return val_.dos_error_;
		else
			throw ExceptionInvalidCase("./smb.pac:19:dos_error", val_case_index(), 0);
		}
	int32 const & status() const
		{
		if ( val_case_index() == 1 )
			return val_.status_;
		else
			throw ExceptionInvalidCase("./smb.pac:20:status", val_case_index(), 1);
		}
	
protected:
	int err_status_type_;
	int val_case_index_;
	union {
		SMB_dos_error * dos_error_;
		int32 status_;
	} val_;
};

static const int smb_header_length = 32;

class SMB_header
{
public:
	SMB_header();
	~SMB_header();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	int const byteorder() const { return byteorder_; };
	array<uint8> const & protocol() const	{ return protocol_; }
	uint8 const & command() const	{ return command_; }
	int const & err_status_type() const 	{ return err_status_type_; }
	SMB_error * const & status() const	{ return status_; }
	uint8 const & flags() const	{ return flags_; }
	uint16 const & flags2() const	{ return flags2_; }
	uint16 const & tid() const	{ return tid_; }
	uint16 const & pid() const	{ return pid_; }
	uint16 const & uid() const	{ return uid_; }
	uint16 const & mid() const	{ return mid_; }
	int const & unicode() const 	{ return unicode_; }
	
protected:
	int byteorder_;
	array<uint8> protocol_;
	uint8 command_;
	int err_status_type_;
	SMB_error * status_;
	uint8 flags_;
	uint16 flags2_;
	uint16 tid_;
	uint16 pid_;
	uint16 uid_;
	uint16 mid_;
	int unicode_;
};


class SMB_body
{
public:
	SMB_body();
	~SMB_body();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	int const byteorder() const { return byteorder_; };
	uint8 const & word_count() const	{ return word_count_; }
	array<uint16> const & parameter_words() const	{ return parameter_words_; }
	uint16 const & byte_count() const	{ return byte_count_; }
	int const & body_length() const 	{ return body_length_; }
	
protected:
	int byteorder_;
	uint8 word_count_;
	array<uint16> parameter_words_;
	uint16 byte_count_;
	int body_length_;
};


class SMB_ascii_string
{
public:
	SMB_ascii_string();
	~SMB_ascii_string();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	array<uint8> const & val() const	{ return val_; }
	
protected:
	array<uint8> val_;
};


class SMB_unicode_string
{
public:
	SMB_unicode_string(int arg_offset);
	~SMB_unicode_string();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	int const offset() const { return offset_; };
	array<uint16> const & s() const	{ return s_; }
	
protected:
	int offset_;
	array<uint16> s_;
};


class SMB_string
{
public:
	SMB_string(int arg_unicode, int arg_offset);
	~SMB_string();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	int const unicode() const { return unicode_; };
	int const offset() const { return offset_; };
	int val_case_index() const	{ return val_case_index_; }
	SMB_ascii_string * const & a() const
		{
		if ( val_case_index() == 0 )
			return val_.a_;
		else
			throw ExceptionInvalidCase("./smb.pac:57:a", val_case_index(), 0);
		}
	SMB_unicode_string * const & u() const
		{
		return val_.u_;
		}
	
protected:
	int unicode_;
	int offset_;
	int val_case_index_;
	union {
		SMB_ascii_string * a_;
		SMB_unicode_string * u_;
	} val_;
};


class SMB_andx
{
public:
	SMB_andx();
	~SMB_andx();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint8 const & command() const	{ return command_; }
	uint8 const & reserved() const	{ return reserved_; }
	uint16 const & offset() const	{ return offset_; }
	
protected:
	uint8 command_;
	uint8 reserved_;
	uint16 offset_;
};


class SMB_generic_andx
{
public:
	SMB_generic_andx();
	~SMB_generic_andx();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint8 const & word_count() const	{ return word_count_; }
	int andx_u_case_index() const	{ return andx_u_case_index_; }
	SMB_andx * const & andx() const
		{
		return andx_u_.andx_;
		}
	
protected:
	uint8 word_count_;
	int andx_u_case_index_;
	union {
		SMB_andx * andx_;
	} andx_u_;
};


class SMB_tree_connect_andx
{
public:
	SMB_tree_connect_andx(int arg_unicode);
	~SMB_tree_connect_andx();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	int const unicode() const { return unicode_; };
	uint8 const & word_count() const	{ return word_count_; }
	SMB_andx * const & andx() const	{ return andx_; }
	uint16 const & flags() const	{ return flags_; }
	uint16 const & password_length() const	{ return password_length_; }
	uint16 const & byte_count() const	{ return byte_count_; }
	array<uint8> const & password() const	{ return password_; }
	SMB_string * const & path() const	{ return path_; }
	SMB_ascii_string * const & service() const	{ return service_; }
	
protected:
	int unicode_;
	uint8 word_count_;
	SMB_andx * andx_;
	uint16 flags_;
	uint16 password_length_;
	uint16 byte_count_;
	array<uint8> password_;
	SMB_string * path_;
	SMB_ascii_string * service_;
};


class SMB_nt_create_andx
{
public:
	SMB_nt_create_andx(int arg_unicode);
	~SMB_nt_create_andx();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	int const unicode() const { return unicode_; };
	uint8 const & word_count() const	{ return word_count_; }
	SMB_andx * const & andx() const	{ return andx_; }
	uint8 const & reserved() const	{ return reserved_; }
	uint16 const & name_length() const	{ return name_length_; }
	uint32 const & flags() const	{ return flags_; }
	array<uint8> const & rest_words() const	{ return rest_words_; }
	uint16 const & byte_count() const	{ return byte_count_; }
	SMB_string * const & name() const	{ return name_; }
	
protected:
	int unicode_;
	uint8 word_count_;
	SMB_andx * andx_;
	uint8 reserved_;
	uint16 name_length_;
	uint32 flags_;
	array<uint8> rest_words_;
	uint16 byte_count_;
	SMB_string * name_;
};


class SMB_read_andx
{
public:
	SMB_read_andx();
	~SMB_read_andx();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint8 const & word_count() const	{ return word_count_; }
	SMB_andx * const & andx() const	{ return andx_; }
	uint16 const & fid() const	{ return fid_; }
	uint32 const & offset() const	{ return offset_; }
	uint16 const & max_count() const	{ return max_count_; }
	uint16 const & min_count() const	{ return min_count_; }
	uint16 const & max_count_high() const	{ return max_count_high_; }
	uint16 const & remaining() const	{ return remaining_; }
	uint32 const & offset_high() const	{ return offset_high_; }
	uint16 const & byte_count() const	{ return byte_count_; }
	
protected:
	uint8 word_count_;
	SMB_andx * andx_;
	uint16 fid_;
	uint32 offset_;
	uint16 max_count_;
	uint16 min_count_;
	uint16 max_count_high_;
	uint16 remaining_;
	uint32 offset_high_;
	uint16 byte_count_;
};


class SMB_read_andx_response
{
public:
	SMB_read_andx_response();
	~SMB_read_andx_response();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint8 const & word_count() const	{ return word_count_; }
	SMB_andx * const & andx() const	{ return andx_; }
	uint16 const & remaining() const	{ return remaining_; }
	uint16 const & data_compact() const	{ return data_compact_; }
	uint16 const & reserved() const	{ return reserved_; }
	uint16 const & data_len() const	{ return data_len_; }
	uint16 const & data_offset() const	{ return data_offset_; }
	uint16 const & data_len_high() const	{ return data_len_high_; }
	array<uint16> const & reserved2() const	{ return reserved2_; }
	uint16 const & byte_count() const	{ return byte_count_; }
	int const & data_length() const 	{ return data_length_; }
	array<uint8> const & data() const	{ return data_; }
	
protected:
	uint8 word_count_;
	SMB_andx * andx_;
	uint16 remaining_;
	uint16 data_compact_;
	uint16 reserved_;
	uint16 data_len_;
	uint16 data_offset_;
	uint16 data_len_high_;
	array<uint16> reserved2_;
	uint16 byte_count_;
	int data_length_;
	array<uint8> data_;
};


class SMB_write_andx
{
public:
	SMB_write_andx();
	~SMB_write_andx();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint8 const & word_count() const	{ return word_count_; }
	SMB_andx * const & andx() const	{ return andx_; }
	uint16 const & fid() const	{ return fid_; }
	uint32 const & offset() const	{ return offset_; }
	uint32 const & reserved() const	{ return reserved_; }
	uint16 const & write_mode() const	{ return write_mode_; }
	uint16 const & remaining() const	{ return remaining_; }
	uint16 const & data_len_high() const	{ return data_len_high_; }
	uint16 const & data_len() const	{ return data_len_; }
	uint16 const & data_offset() const	{ return data_offset_; }
	array<uint8> const & rest_words() const	{ return rest_words_; }
	uint16 const & byte_count() const	{ return byte_count_; }
	int const & data_length() const 	{ return data_length_; }
	array<uint8> const & data() const	{ return data_; }
	
protected:
	uint8 word_count_;
	SMB_andx * andx_;
	uint16 fid_;
	uint32 offset_;
	uint32 reserved_;
	uint16 write_mode_;
	uint16 remaining_;
	uint16 data_len_high_;
	uint16 data_len_;
	uint16 data_offset_;
	array<uint8> rest_words_;
	uint16 byte_count_;
	int data_length_;
	array<uint8> data_;
};


class SMB_write_andx_response
{
public:
	SMB_write_andx_response();
	~SMB_write_andx_response();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint8 const & word_count() const	{ return word_count_; }
	SMB_andx * const & andx() const	{ return andx_; }
	uint16 const & count() const	{ return count_; }
	uint16 const & remaining() const	{ return remaining_; }
	uint32 const & reserved() const	{ return reserved_; }
	uint16 const & byte_count() const	{ return byte_count_; }
	
protected:
	uint8 word_count_;
	SMB_andx * andx_;
	uint16 count_;
	uint16 remaining_;
	uint32 reserved_;
	uint16 byte_count_;
};


class SMB_transaction
{
public:
	SMB_transaction(int arg_trans_type, int arg_unicode);
	~SMB_transaction();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	int const trans_type() const { return trans_type_; };
	int const unicode() const { return unicode_; };
	uint8 const & word_count() const	{ return word_count_; }
	uint16 const & total_param_count() const	{ return total_param_count_; }
	uint16 const & total_data_count() const	{ return total_data_count_; }
	uint16 const & max_param_count() const	{ return max_param_count_; }
	uint16 const & max_data_count() const	{ return max_data_count_; }
	uint8 const & max_setup_count() const	{ return max_setup_count_; }
	uint8 const & reserved() const	{ return reserved_; }
	uint16 const & flags() const	{ return flags_; }
	uint32 const & timeout() const	{ return timeout_; }
	uint16 const & reserved2() const	{ return reserved2_; }
	uint16 const & param_count() const	{ return param_count_; }
	uint16 const & param_offset() const	{ return param_offset_; }
	uint16 const & data_count() const	{ return data_count_; }
	uint16 const & data_offset() const	{ return data_offset_; }
	uint8 const & setup_count() const	{ return setup_count_; }
	uint8 const & reserved3() const	{ return reserved3_; }
	array<uint16> const & setup() const	{ return setup_; }
	uint16 const & byte_count() const	{ return byte_count_; }
	int name_u_case_index() const	{ return name_u_case_index_; }
	SMB_string * const & name() const
		{
		if ( name_u_case_index() == 1 )
			return name_u_.name_;
		else
			throw ExceptionInvalidCase("./smb.pac:173:name", name_u_case_index(), 1);
		}
	array<uint8> const & parameters() const	{ return parameters_; }
	array<uint8> const & data() const	{ return data_; }
	
protected:
	int trans_type_;
	int unicode_;
	uint8 word_count_;
	uint16 total_param_count_;
	uint16 total_data_count_;
	uint16 max_param_count_;
	uint16 max_data_count_;
	uint8 max_setup_count_;
	uint8 reserved_;
	uint16 flags_;
	uint32 timeout_;
	uint16 reserved2_;
	uint16 param_count_;
	uint16 param_offset_;
	uint16 data_count_;
	uint16 data_offset_;
	uint8 setup_count_;
	uint8 reserved3_;
	array<uint16> setup_;
	uint16 byte_count_;
	int name_u_case_index_;
	union {
		SMB_string * name_;
	} name_u_;
	array<uint8> parameters_;
	array<uint8> data_;
};


class SMB_transaction_secondary
{
public:
	SMB_transaction_secondary(int arg_unicode);
	~SMB_transaction_secondary();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	int const unicode() const { return unicode_; };
	int const & smb_header_length() const 	{ return smb_header_length_; }
	uint8 const & word_count() const	{ return word_count_; }
	uint16 const & total_param_count() const	{ return total_param_count_; }
	uint16 const & total_data_count() const	{ return total_data_count_; }
	uint16 const & param_count() const	{ return param_count_; }
	uint16 const & param_offset() const	{ return param_offset_; }
	uint16 const & param_displacement() const	{ return param_displacement_; }
	uint16 const & data_count() const	{ return data_count_; }
	uint16 const & data_offset() const	{ return data_offset_; }
	uint16 const & data_displacement() const	{ return data_displacement_; }
	uint16 const & fid() const	{ return fid_; }
	uint16 const & byte_count() const	{ return byte_count_; }
	array<uint8> const & parameters() const	{ return parameters_; }
	array<uint8> const & data() const	{ return data_; }
	
protected:
	int unicode_;
	int smb_header_length_;
	uint8 word_count_;
	uint16 total_param_count_;
	uint16 total_data_count_;
	uint16 param_count_;
	uint16 param_offset_;
	uint16 param_displacement_;
	uint16 data_count_;
	uint16 data_offset_;
	uint16 data_displacement_;
	uint16 fid_;
	uint16 byte_count_;
	array<uint8> parameters_;
	array<uint8> data_;
};


class SMB_transaction_response
{
public:
	SMB_transaction_response(int arg_unicode);
	~SMB_transaction_response();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	int const unicode() const { return unicode_; };
	int const & smb_header_length() const 	{ return smb_header_length_; }
	uint8 const & word_count() const	{ return word_count_; }
	uint16 const & total_param_count() const	{ return total_param_count_; }
	uint16 const & total_data_count() const	{ return total_data_count_; }
	uint16 const & reserved() const	{ return reserved_; }
	uint16 const & param_count() const	{ return param_count_; }
	uint16 const & param_offset() const	{ return param_offset_; }
	uint16 const & param_displacement() const	{ return param_displacement_; }
	uint16 const & data_count() const	{ return data_count_; }
	uint16 const & data_offset() const	{ return data_offset_; }
	uint16 const & data_displacement() const	{ return data_displacement_; }
	uint8 const & setup_count() const	{ return setup_count_; }
	uint8 const & reserved2() const	{ return reserved2_; }
	array<uint16> const & setup() const	{ return setup_; }
	uint16 const & byte_count() const	{ return byte_count_; }
	array<uint8> const & parameters() const	{ return parameters_; }
	array<uint8> const & data() const	{ return data_; }
	
protected:
	int unicode_;
	int smb_header_length_;
	uint8 word_count_;
	uint16 total_param_count_;
	uint16 total_data_count_;
	uint16 reserved_;
	uint16 param_count_;
	uint16 param_offset_;
	uint16 param_displacement_;
	uint16 data_count_;
	uint16 data_offset_;
	uint16 data_displacement_;
	uint8 setup_count_;
	uint8 reserved2_;
	array<uint16> setup_;
	uint16 byte_count_;
	array<uint8> parameters_;
	array<uint8> data_;
};


class SMB_get_dfs_referral
{
public:
	SMB_get_dfs_referral(int arg_unicode);
	~SMB_get_dfs_referral();
	int parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder);
	
	// Member access functions
	int const unicode() const { return unicode_; };
	uint16 const & max_referral_level() const	{ return max_referral_level_; }
	SMB_string * const & file_name() const	{ return file_name_; }
	
protected:
	int unicode_;
	uint16 max_referral_level_;
	SMB_string * file_name_;
};

} /* namespace BinPAC */
#endif /* smb_pac_h */
